"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function mulMod(a, b, n) {
    return (a * b) % n;
}
function miller_rabin(n, k) {
    if (n === k) {
        return true;
    }
    var s = 0;
    var d = n - 1;
    for (; !(d & 1); s++) {
        d >>= 1;
    }
    var x = 1;
    var b = k % n;
    var e = d;
    for (; e; e >>>= 1) {
        if (e & 1) {
            x = mulMod(x, b, n);
        }
        b = mulMod(b, b, n);
    }
    if (x === 1 || x === n - 1) {
        return true;
    }
    while (s-- > 1) {
        x = mulMod(x, x, n);
        if (x === 1) {
            return false;
        }
        if (x === n - 1) {
            return true;
        }
    }
    return false;
}
function is_prime(n) {
    return n > 1 && (n === Math.round(n)) && ((n > 73 &&
        !(n % 2 &&
            n % 3 &&
            n % 5 &&
            n % 7 &&
            n % 11 &&
            n % 13 &&
            n % 17 &&
            n % 19 &&
            n % 23 &&
            n % 29 &&
            n % 31 &&
            n % 37 &&
            n % 41 &&
            n % 43 &&
            n % 47 &&
            n % 53 &&
            n % 59 &&
            n % 61 &&
            n % 67 &&
            n % 71 &&
            n % 73))
        ? false
        : miller_rabin(n, 2) &&
            miller_rabin(n, 7) &&
            miller_rabin(n, 61));
}
exports.is_prime = is_prime;
