"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var r = require("resul-ts");
var inversify_1 = require("inversify");
var H = require("../di_interfaces");
var di_symbols_1 = require("../di_symbols");
var block_xml_1 = require("./block_xml");
var block_config_1 = require("./block_config");
var domain_functions_1 = require("./domain_functions");
var BenchmarkBlockProviderFactoryImpl = (function () {
    function BenchmarkBlockProviderFactoryImpl(bxbf) {
        this.bxbf = bxbf;
    }
    BenchmarkBlockProviderFactoryImpl.prototype.runtime_provider = function (benchmark_dependencies) {
        return {
            namespace: function () { return 'BENCHMARK'; },
            domain_functions: domain_functions_1.get_domain_functions(benchmark_dependencies),
            action_types: function () { return []; },
        };
    };
    BenchmarkBlockProviderFactoryImpl.prototype.block_provider_and_xml = function (test_icon_url, benchmark_dependencies) {
        var _this = this;
        var runtime_provider = this.runtime_provider(benchmark_dependencies);
        var block_provider = tslib_1.__assign({}, runtime_provider, { config: block_config_1.get_block_config(test_icon_url) });
        return {
            get_block_provider: function () { return block_provider; },
            get_default_block_xml: function () {
                if (_this.bxbf == undefined) {
                    return r.fail('Heart workspace requirements unfulfilled, cannot get BlockXML for benchmark blocks.');
                }
                var bxml_builder = _this.bxbf.create(block_provider);
                block_xml_1.apply_test_block_defaults(bxml_builder);
                return r.success(bxml_builder.get_block_xml());
            },
        };
    };
    BenchmarkBlockProviderFactoryImpl = tslib_1.__decorate([
        inversify_1.injectable(),
        tslib_1.__param(0, inversify_1.inject(di_symbols_1.BINDING.BlockXmlBuilderFactory)), tslib_1.__param(0, inversify_1.optional()),
        tslib_1.__metadata("design:paramtypes", [Object])
    ], BenchmarkBlockProviderFactoryImpl);
    return BenchmarkBlockProviderFactoryImpl;
}());
exports.BenchmarkBlockProviderFactoryImpl = BenchmarkBlockProviderFactoryImpl;
