import { BlockRegistry, Logger, Ohno, BlockPredicates } from './di_interfaces';
import * as B from './block_types';
export declare class BlockPredicatesImpl implements BlockPredicates {
    private block_registry;
    private ohno;
    private log;
    constructor(block_registry: BlockRegistry, ohno: Ohno, log: Logger);
    responder_block(b: B.Block): b is B.ResponderBlock;
    responder_type(t: string): boolean;
    atomic_type(t: string): boolean;
    async_tell(b: B.Block): b is B.TellBlock;
    sync_tell(b: B.Block): b is B.SyncTellBlock;
    warp(b: B.Block): b is B.WarpBlock;
    logic_empty(b: B.Block): b is B.LogicEmptyBlock;
    special_block(b: B.Block): b is B.SpecialBlock;
    domain_block(b: B.Block): b is B.DomainBlock;
    loop_block(b: B.Block): b is B.LoopBlock;
    cond_block(b: B.Block): b is B.CondBlock;
    proc_block(b: B.Block): b is B.ProcBlock;
    controls_if(b: B.Block): b is B.IfBlock;
    controls_if_no_else(b: B.Block): b is B.IfNoElseBlock;
    event_block(b: B.Block): b is B.EventBlock;
    repeat_n_times(b: B.Block): b is B.RepeatNTimesBlock;
    repeat_forever(b: B.Block): b is B.RepeatForeverBlock;
    repeat_forever_until(b: B.Block): b is B.RepeatForeverUntilBlock;
    wait_until(b: B.Block): b is B.WaitUntilBlock;
    break(b: B.Block): b is B.BreakBlock;
    procedures_defnoreturn(b: B.Block): b is B.ProcedureDefinitionBlock;
    procedures_callreturn(b: B.Block): b is B.ProcedureCallReturnBlock;
    procedures_callnoreturn(b: B.Block): b is B.ProcedureCallNoReturnBlock;
    procedures_return_value(b: B.Block): b is B.ProcedureReturnValueBlock;
    procedures_parameter(b: B.Block): b is B.ProcedureParameterBlock;
    compiled_block(b: B.BlockParam): b is B.CompiledBlock;
    atomic(b: B.BlockParam): b is number | string | boolean | undefined;
}
