"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _includes = require("lodash/includes");
var ResponderType;
(function (ResponderType) {
    ResponderType["Action"] = "action";
    ResponderType["State"] = "state";
    ResponderType["Dynamic"] = "dynamic";
    ResponderType["Constructor"] = "constructor";
    ResponderType["Destructor"] = "destructor";
})(ResponderType = exports.ResponderType || (exports.ResponderType = {}));
function parse_namespaced_id(ns_id) {
    if (!_includes(ns_id, '__')) {
        return {
            namespace: '',
            function_id: ns_id,
        };
    }
    var ns_length = ns_id.indexOf('__');
    return {
        namespace: ns_id.substring(0, ns_length),
        function_id: ns_id.substring(ns_length + 2),
    };
}
exports.parse_namespaced_id = parse_namespaced_id;
function namespaced_id(namespace, function_name) {
    if (namespace == '') {
        return function_name;
    }
    return namespace + '__' + function_name;
}
exports.namespaced_id = namespaced_id;
