import { Blockly } from './blockly_interface';
import { FunctionDict } from './block_provider';
import { BlockRegistry } from './di_interfaces';
import { LoadedBlockConfigs } from './public_interfaces';
import { Action, ActionSpec, BlockProvider, ResponderInfo, RuntimeProvider } from './block_provider';
export declare type MaybeActionSpec = ActionSpec | undefined;
export declare type MaybeResponderInfo = ResponderInfo | undefined;
export declare class BlockRegistryImpl implements BlockRegistry {
    private blockly;
    constructor(blockly?: Blockly | undefined);
    private action_specs;
    private responder_infos;
    private domain_functions;
    private blocks_need_restart_when_finished;
    private blocks_need_finish_out_of_run_group;
    private loaded_json_block_configs;
    private loaded_init_function_block_configs;
    register_provider(p: BlockProvider): void;
    get_loaded_block_configs(): LoadedBlockConfigs;
    register_runtime_provider(p: RuntimeProvider): void;
    get_action_spec(ns_event_id: string): MaybeActionSpec;
    get_spec_of_action(event: Action): MaybeActionSpec;
    has_responder_type(ns_responder_id: string): boolean;
    get_responder_info(ns_responder_id: string): MaybeResponderInfo;
    get_event_types(): string[];
    get_domain_functions(): FunctionDict;
    block_restart_when_finished(ns_id: string): boolean;
    block_finish_out_of_run_group(ns_id: string): boolean;
    private define_blocks(blockly, p);
}
