"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var _includes = require("lodash/includes");
var _some = require("lodash/some");
var inversify_1 = require("inversify");
var di_symbols_1 = require("./di_symbols");
var BlockUtilImpl = (function () {
    function BlockUtilImpl(is, block_registry, ohno, log) {
        this.is = is;
        this.block_registry = block_registry;
        this.ohno = ohno;
        this.log = log;
    }
    BlockUtilImpl.prototype.reset_state = function (block) {
        block.first_evaluation = true;
        block.done_evaluating = false;
    };
    BlockUtilImpl.prototype.get_first_ancestor_satisfying = function (block, assert) {
        if (block == undefined) {
            return undefined;
        }
        if (!block.parent_block) {
            return undefined;
        }
        if (assert(block.parent_block)) {
            return block.parent_block;
        }
        return this.get_first_ancestor_satisfying(block.parent_block, assert);
    };
    BlockUtilImpl.prototype.has_block_of_types = function (cws, block_types) {
        function find_in_json(block) {
            if (!block) {
                return false;
            }
            return _includes(block_types, block.type)
                || _some(block.child_block, find_in_json)
                || find_in_json(block.next_block);
        }
        return _some(cws, function (cw) {
            var found_in_procs = _some(cw.procedures, find_in_json);
            if (cw.compiled_block_map) {
                return found_in_procs || _some(cw.compiled_block_map, find_in_json);
            }
            return found_in_procs;
        });
    };
    BlockUtilImpl = tslib_1.__decorate([
        inversify_1.injectable(),
        tslib_1.__param(0, inversify_1.inject(di_symbols_1.BINDING.BlockPredicates)),
        tslib_1.__param(1, inversify_1.inject(di_symbols_1.BINDING.BlockRegistry)),
        tslib_1.__param(2, inversify_1.inject(di_symbols_1.BINDING.Ohno)),
        tslib_1.__param(3, inversify_1.inject(di_symbols_1.BINDING.Log)),
        tslib_1.__metadata("design:paramtypes", [Object, Object, Object, Object])
    ], BlockUtilImpl);
    return BlockUtilImpl;
}());
exports.BlockUtilImpl = BlockUtilImpl;
