"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var inversify_1 = require("inversify");
var di_symbols_1 = require("./di_symbols");
var block_provider_1 = require("./block_provider");
var BlockXMLBuilderImpl = (function () {
    function BlockXMLBuilderImpl(block_provider, blockly) {
        this.block_xml = {};
        this.namespace = block_provider.namespace();
        var config = block_provider.config(blockly);
        for (var block_type in config) {
            this.define_block_xml(block_type);
        }
    }
    BlockXMLBuilderImpl.prototype.define_block_xml = function (block_type, xml, gap, real_block_type) {
        if (xml === void 0) { xml = ''; }
        var ns_id = block_provider_1.namespaced_id(this.namespace, block_type);
        real_block_type = real_block_type || ns_id;
        gap = gap || '10';
        this.block_xml[ns_id] = "<block type=\"" + real_block_type + "\" gap=\"" + gap + "\">" + xml + "</block>";
    };
    BlockXMLBuilderImpl.prototype.get_block_xml = function () {
        return this.block_xml;
    };
    return BlockXMLBuilderImpl;
}());
var BlockXMLBuilderFactoryImpl = (function () {
    function BlockXMLBuilderFactoryImpl(blockly) {
        this.blockly = blockly;
    }
    BlockXMLBuilderFactoryImpl.prototype.create = function (block_provider) {
        return new BlockXMLBuilderImpl(block_provider, this.blockly);
    };
    BlockXMLBuilderFactoryImpl = tslib_1.__decorate([
        inversify_1.injectable(),
        tslib_1.__param(0, inversify_1.inject(di_symbols_1.BINDING.Blockly)),
        tslib_1.__metadata("design:paramtypes", [Object])
    ], BlockXMLBuilderFactoryImpl);
    return BlockXMLBuilderFactoryImpl;
}());
exports.BlockXMLBuilderFactoryImpl = BlockXMLBuilderFactoryImpl;
