import * as H from './di_interfaces';
export interface HeartConfig {
    block_pool_preallocation_size: number;
    deterministic?: DeterministicConfig;
    legacy: LegacyConfig;
    max_procedure_calls_per_interpreter_step: number;
    max_warp_iterations_per_interpreter_step: number;
    opti_compiler: OptiCompiler;
    per_entity_clone_limit?: number;
    entity_max_clones_per_frame: number;
    reports_all_entities: boolean;
    should_report_current_running_block: boolean;
    user_debug_mode: boolean;
    max_call_stack_size: number;
}
export interface LegacyConfig {
    lists_get_value_allow_return_undefined: boolean;
}
export interface DeterministicConfig {
    seconds_per_update: number;
    prng_seed: number | number[];
}
export interface OptiCompiler {
    pretty_print: boolean;
}
export interface PartialHeartConfig {
    block_pool_preallocation_size?: number;
    deterministic?: DeterministicConfig;
    legacy?: Partial<LegacyConfig>;
    max_procedure_calls_per_interpreter_step?: number;
    max_warp_iterations_per_interpreter_step?: number;
    opti_compiler?: Partial<OptiCompiler>;
    per_entity_clone_limit?: number;
    entity_max_clones_per_frame?: number;
    reports_all_entities?: boolean;
    should_report_current_running_block?: boolean;
    user_debug_mode?: boolean;
    max_call_stack_size?: number;
}
export declare class ConfigImpl implements H.Config {
    private event_bus;
    private config;
    constructor(event_bus: H.EventBusPrivate);
    get(): HeartConfig;
    set(config: PartialHeartConfig): void;
}
