"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var _defaultsDeep = require("lodash/defaultsDeep");
var inversify_1 = require("inversify");
var H = require("./di_interfaces");
var di_symbols_1 = require("./di_symbols");
function get_defaults() {
    return {
        block_pool_preallocation_size: 50,
        deterministic: undefined,
        legacy: {
            lists_get_value_allow_return_undefined: false,
        },
        max_procedure_calls_per_interpreter_step: 50000,
        max_warp_iterations_per_interpreter_step: 30000,
        opti_compiler: {
            pretty_print: false,
        },
        per_entity_clone_limit: 300,
        entity_max_clones_per_frame: 300,
        reports_all_entities: true,
        should_report_current_running_block: false,
        user_debug_mode: false,
        max_call_stack_size: 3000,
    };
}
var ConfigImpl = (function () {
    function ConfigImpl(event_bus) {
        this.event_bus = event_bus;
    }
    ConfigImpl.prototype.get = function () {
        return this.config;
    };
    ConfigImpl.prototype.set = function (config) {
        this.config = _defaultsDeep({}, config, this.config, get_defaults());
        this.event_bus.system.config_updated.send();
    };
    ConfigImpl = tslib_1.__decorate([
        inversify_1.injectable(),
        tslib_1.__param(0, inversify_1.inject(di_symbols_1.BINDING.EventBus)),
        tslib_1.__metadata("design:paramtypes", [Object])
    ], ConfigImpl);
    return ConfigImpl;
}());
exports.ConfigImpl = ConfigImpl;
