import { Container } from 'inversify';
import * as H from './di_interfaces';
import { Blockly } from './blockly_interface';
import { PartialHeartConfig } from './config';
import { DOMParser } from './dom_parser';
import { DayNames } from './basic_types';
export interface DomCompilerSpec {
    dom_parser: DOMParser;
}
export interface HtmlCompilerSpec {
    html_parser: any;
}
export interface InstanceSpec {
    configuration: PartialHeartConfig;
    logger: H.Logger;
    compiler_requirements?: DomCompilerSpec | HtmlCompilerSpec;
    workspace_requirements?: {
        blockly: Blockly;
    };
    basic_blocks_requirements?: BasicBlockRequirementsSpec;
}
export interface BasicBlockRequirementsSpec {
    day_names: DayNames;
}
export declare function get_instance(spec: InstanceSpec): Container;
