import * as nbus from 'nekobasu';
import * as E from './event_types';
export declare function create_variable_neko(): {
    immediate: nbus.interfaces.EventBuffer<E.VariableUpdate, E.VariableUpdate>;
    instrumented_last: nbus.interfaces.EventBuffer<E.VariableUpdate, nbus.builtin.event_buffers.InstrumentedLast<E.VariableUpdate>>;
    last: nbus.interfaces.EventBuffer<E.VariableUpdate, E.VariableUpdate>;
    list: nbus.interfaces.EventBuffer<E.VariableUpdate, E.VariableUpdate[]>;
} & {
    merged: nbus.interfaces.EventBuffer<E.VariableUpdate, E.VariableReduction>;
} & nbus.interfaces.Neko<E.VariableUpdate, "immediate" | "instrumented_last" | "last" | "list" | "merged">;
export declare function create_list_neko(): {
    immediate: nbus.interfaces.EventBuffer<E.ListUpdate, E.ListUpdate>;
    instrumented_last: nbus.interfaces.EventBuffer<E.ListUpdate, nbus.builtin.event_buffers.InstrumentedLast<E.ListUpdate>>;
    last: nbus.interfaces.EventBuffer<E.ListUpdate, E.ListUpdate>;
    list: nbus.interfaces.EventBuffer<E.ListUpdate, E.ListUpdate[]>;
} & {
    merged: nbus.interfaces.EventBuffer<E.ListUpdate, E.ListUpdateReduction>;
} & nbus.interfaces.Neko<E.ListUpdate, "immediate" | "instrumented_last" | "last" | "list" | "merged">;
export declare function create_entity_variable_neko(): {
    immediate: nbus.interfaces.EventBuffer<E.EntityVariableUpdate, E.EntityVariableUpdate>;
    instrumented_last: nbus.interfaces.EventBuffer<E.EntityVariableUpdate, nbus.builtin.event_buffers.InstrumentedLast<E.EntityVariableUpdate>>;
    last: nbus.interfaces.EventBuffer<E.EntityVariableUpdate, E.EntityVariableUpdate>;
    list: nbus.interfaces.EventBuffer<E.EntityVariableUpdate, E.EntityVariableUpdate[]>;
} & {
    merged: nbus.interfaces.EventBuffer<E.EntityVariableUpdate, E.EntityVariableReduction>;
} & nbus.interfaces.Neko<E.EntityVariableUpdate, "immediate" | "instrumented_last" | "last" | "list" | "merged">;
export declare function create_entity_list_neko(): {
    immediate: nbus.interfaces.EventBuffer<E.EntityListUpdate, E.EntityListUpdate>;
    instrumented_last: nbus.interfaces.EventBuffer<E.EntityListUpdate, nbus.builtin.event_buffers.InstrumentedLast<E.EntityListUpdate>>;
    last: nbus.interfaces.EventBuffer<E.EntityListUpdate, E.EntityListUpdate>;
    list: nbus.interfaces.EventBuffer<E.EntityListUpdate, E.EntityListUpdate[]>;
} & {
    merged: nbus.interfaces.EventBuffer<E.EntityListUpdate, E.EntityListReduction>;
} & nbus.interfaces.Neko<E.EntityListUpdate, "immediate" | "instrumented_last" | "last" | "list" | "merged">;
import { EventBuffer, EventBus, EventCategories, Neko, SignalNeko } from 'nekobasu/build/interfaces';
import { ISimpleEvent } from 'nekobasu/build/util';
import { BuiltinEventNeko } from 'nekobasu/build/builtin';
import { InstrumentedLast } from 'nekobasu/build/builtin_event_buffers';
export { EventBuffer, EventBus, EventCategories, InstrumentedLast, BuiltinEventNeko, Neko, SignalNeko, ISimpleEvent };
