"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var nbus = require("nekobasu");
function create_variable_event_buffer() {
    return nbus.event_buffer.create({
        reducer: function (acc, next) {
            acc[next.var_id] = next.new_value;
            return acc;
        },
        start_value: {},
    });
}
function create_list_event_buffer() {
    return nbus.event_buffer.create({
        reducer: function (acc, next) {
            acc[next.list_id] = next.new_value;
            return acc;
        },
        start_value: {},
    });
}
function create_entity_variable_event_buffer() {
    return nbus.event_buffer.create({
        reducer: function (acc, next) {
            if (acc[next.entity_id] === undefined) {
                acc[next.entity_id] = {};
            }
            acc[next.entity_id][next.var_id] = next.new_value;
            return acc;
        },
        start_value: {},
    });
}
function create_entity_list_event_buffer() {
    return nbus.event_buffer.create({
        reducer: function (acc, next) {
            if (acc[next.entity_id] === undefined) {
                acc[next.entity_id] = {};
            }
            acc[next.entity_id][next.list_id] = next.new_value;
            return acc;
        },
        start_value: {},
    });
}
function create_variable_neko() {
    var buf_dict = nbus.util.merge_event_buffers(nbus.builtin.event_ebs(), { merged: create_variable_event_buffer() });
    return nbus.neko.create_for_event(buf_dict);
}
exports.create_variable_neko = create_variable_neko;
function create_list_neko() {
    var buf_dict = nbus.util.merge_event_buffers(nbus.builtin.event_ebs(), { merged: create_list_event_buffer() });
    return nbus.neko.create_for_event(buf_dict);
}
exports.create_list_neko = create_list_neko;
function create_entity_variable_neko() {
    var buf_dict = nbus.util.merge_event_buffers(nbus.builtin.event_ebs(), { merged: create_entity_variable_event_buffer() });
    return nbus.neko.create_for_event(buf_dict);
}
exports.create_entity_variable_neko = create_entity_variable_neko;
function create_entity_list_neko() {
    var buf_dict = nbus.util.merge_event_buffers(nbus.builtin.event_ebs(), { merged: create_entity_list_event_buffer() });
    return nbus.neko.create_for_event(buf_dict);
}
exports.create_entity_list_neko = create_entity_list_neko;
