import * as nbus from 'nekobasu';
import * as E from './event_types';
export declare function create_event_bus(): {
    error: {
        runtime: nbus.builtin.BuiltinEventNeko<E.RuntimeError>;
        all: nbus.builtin.BuiltinEventNeko<E.GeneralError>;
    } & nbus.interfaces.EventBus<"all" | "runtime">;
    warning: {
        runtime: nbus.builtin.BuiltinEventNeko<E.RuntimeError>;
        all: nbus.builtin.BuiltinEventNeko<E.GeneralError>;
    } & nbus.interfaces.EventBus<"all" | "runtime">;
    runtime_manager: {
        after_update: {
            count: nbus.interfaces.EventBuffer<any, number>;
            immediate: nbus.interfaces.EventBuffer<undefined, undefined>;
        } & nbus.interfaces.SignalNeko<"immediate" | "count">;
        before_update: {
            count: nbus.interfaces.EventBuffer<any, number>;
            immediate: nbus.interfaces.EventBuffer<undefined, undefined>;
        } & nbus.interfaces.SignalNeko<"immediate" | "count">;
        restart: {
            count: nbus.interfaces.EventBuffer<any, number>;
            immediate: nbus.interfaces.EventBuffer<undefined, undefined>;
        } & nbus.interfaces.SignalNeko<"immediate" | "count">;
        stop: {
            count: nbus.interfaces.EventBuffer<any, number>;
            immediate: nbus.interfaces.EventBuffer<undefined, undefined>;
        } & nbus.interfaces.SignalNeko<"immediate" | "count">;
        start: {
            count: nbus.interfaces.EventBuffer<any, number>;
            immediate: nbus.interfaces.EventBuffer<undefined, undefined>;
        } & nbus.interfaces.SignalNeko<"immediate" | "count">;
        idle: {
            count: nbus.interfaces.EventBuffer<any, number>;
            immediate: nbus.interfaces.EventBuffer<undefined, undefined>;
        } & nbus.interfaces.SignalNeko<"immediate" | "count">;
    } & nbus.interfaces.EventBus<"stop" | "start" | "after_update" | "before_update" | "restart" | "idle">;
    runtime_data: {
        variable_update: {
            immediate: nbus.interfaces.EventBuffer<E.VariableUpdate, E.VariableUpdate>;
            instrumented_last: nbus.interfaces.EventBuffer<E.VariableUpdate, nbus.builtin.event_buffers.InstrumentedLast<E.VariableUpdate>>;
            last: nbus.interfaces.EventBuffer<E.VariableUpdate, E.VariableUpdate>;
            list: nbus.interfaces.EventBuffer<E.VariableUpdate, E.VariableUpdate[]>;
        } & {
            merged: nbus.interfaces.EventBuffer<E.VariableUpdate, E.VariableReduction>;
        } & nbus.interfaces.Neko<E.VariableUpdate, "immediate" | "instrumented_last" | "last" | "list" | "merged">;
        list_update: {
            immediate: nbus.interfaces.EventBuffer<E.ListUpdate, E.ListUpdate>;
            instrumented_last: nbus.interfaces.EventBuffer<E.ListUpdate, nbus.builtin.event_buffers.InstrumentedLast<E.ListUpdate>>;
            last: nbus.interfaces.EventBuffer<E.ListUpdate, E.ListUpdate>;
            list: nbus.interfaces.EventBuffer<E.ListUpdate, E.ListUpdate[]>;
        } & {
            merged: nbus.interfaces.EventBuffer<E.ListUpdate, E.ListUpdateReduction>;
        } & nbus.interfaces.Neko<E.ListUpdate, "immediate" | "instrumented_last" | "last" | "list" | "merged">;
        entity_variable_update: {
            immediate: nbus.interfaces.EventBuffer<E.EntityVariableUpdate, E.EntityVariableUpdate>;
            instrumented_last: nbus.interfaces.EventBuffer<E.EntityVariableUpdate, nbus.builtin.event_buffers.InstrumentedLast<E.EntityVariableUpdate>>;
            last: nbus.interfaces.EventBuffer<E.EntityVariableUpdate, E.EntityVariableUpdate>;
            list: nbus.interfaces.EventBuffer<E.EntityVariableUpdate, E.EntityVariableUpdate[]>;
        } & {
            merged: nbus.interfaces.EventBuffer<E.EntityVariableUpdate, E.EntityVariableReduction>;
        } & nbus.interfaces.Neko<E.EntityVariableUpdate, "immediate" | "instrumented_last" | "last" | "list" | "merged">;
        entity_list_update: {
            immediate: nbus.interfaces.EventBuffer<E.EntityListUpdate, E.EntityListUpdate>;
            instrumented_last: nbus.interfaces.EventBuffer<E.EntityListUpdate, nbus.builtin.event_buffers.InstrumentedLast<E.EntityListUpdate>>;
            last: nbus.interfaces.EventBuffer<E.EntityListUpdate, E.EntityListUpdate>;
            list: nbus.interfaces.EventBuffer<E.EntityListUpdate, E.EntityListUpdate[]>;
        } & {
            merged: nbus.interfaces.EventBuffer<E.EntityListUpdate, E.EntityListReduction>;
        } & nbus.interfaces.Neko<E.EntityListUpdate, "immediate" | "instrumented_last" | "last" | "list" | "merged">;
        entity_dispose: nbus.builtin.BuiltinEventNeko<E.EntityDisposed>;
        block_run_result: nbus.builtin.BuiltinEventNeko<E.BlockResult>;
        test_done: {
            count: nbus.interfaces.EventBuffer<any, number>;
            immediate: nbus.interfaces.EventBuffer<undefined, undefined>;
        } & nbus.interfaces.SignalNeko<"immediate" | "count">;
        block_running: nbus.builtin.BuiltinEventNeko<string>;
        block_finished: nbus.builtin.BuiltinEventNeko<string>;
    } & nbus.interfaces.EventBus<"variable_update" | "list_update" | "entity_variable_update" | "entity_list_update" | "entity_dispose" | "block_run_result" | "test_done" | "block_running" | "block_finished">;
    system: {
        config_updated: {
            count: nbus.interfaces.EventBuffer<any, number>;
            immediate: nbus.interfaces.EventBuffer<undefined, undefined>;
        } & nbus.interfaces.SignalNeko<"immediate" | "count">;
    } & nbus.interfaces.EventBus<"config_updated">;
    clones: {
        dispose_clone: nbus.builtin.BuiltinEventNeko<string>;
    } & nbus.interfaces.EventBus<"dispose_clone">;
} & nbus.interfaces.EventCategories<"error" | "warning" | "runtime_manager" | "runtime_data" | "system" | "clones">;
export declare function as_public_event_bus(eb: EventBusPrivate): {
    error: {
        runtime: {
            immediate: nbus.util.ISimpleEvent<E.RuntimeError>;
            instrumented_last: nbus.util.ISimpleEvent<nbus.builtin.event_buffers.InstrumentedLast<E.RuntimeError>>;
            last: nbus.util.ISimpleEvent<E.RuntimeError>;
            list: nbus.util.ISimpleEvent<E.RuntimeError[]>;
        };
        all: {
            immediate: nbus.util.ISimpleEvent<E.GeneralError>;
            instrumented_last: nbus.util.ISimpleEvent<nbus.builtin.event_buffers.InstrumentedLast<E.GeneralError>>;
            last: nbus.util.ISimpleEvent<E.GeneralError>;
            list: nbus.util.ISimpleEvent<E.GeneralError[]>;
        };
    };
    warning: {
        runtime: {
            immediate: nbus.util.ISimpleEvent<E.RuntimeError>;
            instrumented_last: nbus.util.ISimpleEvent<nbus.builtin.event_buffers.InstrumentedLast<E.RuntimeError>>;
            last: nbus.util.ISimpleEvent<E.RuntimeError>;
            list: nbus.util.ISimpleEvent<E.RuntimeError[]>;
        };
        all: {
            immediate: nbus.util.ISimpleEvent<E.GeneralError>;
            instrumented_last: nbus.util.ISimpleEvent<nbus.builtin.event_buffers.InstrumentedLast<E.GeneralError>>;
            last: nbus.util.ISimpleEvent<E.GeneralError>;
            list: nbus.util.ISimpleEvent<E.GeneralError[]>;
        };
    };
    runtime_manager: {
        after_update: {
            immediate: nbus.util.ISimpleEvent<undefined>;
            count: nbus.util.ISimpleEvent<number>;
        };
        before_update: {
            immediate: nbus.util.ISimpleEvent<undefined>;
            count: nbus.util.ISimpleEvent<number>;
        };
        restart: {
            immediate: nbus.util.ISimpleEvent<undefined>;
            count: nbus.util.ISimpleEvent<number>;
        };
        stop: {
            immediate: nbus.util.ISimpleEvent<undefined>;
            count: nbus.util.ISimpleEvent<number>;
        };
        start: {
            immediate: nbus.util.ISimpleEvent<undefined>;
            count: nbus.util.ISimpleEvent<number>;
        };
        idle: {
            immediate: nbus.util.ISimpleEvent<undefined>;
            count: nbus.util.ISimpleEvent<number>;
        };
    };
    runtime_data: {
        variable_update: {
            merged: nbus.util.ISimpleEvent<E.VariableReduction>;
            last: nbus.util.ISimpleEvent<E.VariableUpdate>;
            list: nbus.util.ISimpleEvent<E.VariableUpdate[]>;
            immediate: nbus.util.ISimpleEvent<E.VariableUpdate>;
        };
        list_update: {
            merged: nbus.util.ISimpleEvent<E.ListUpdateReduction>;
            last: nbus.util.ISimpleEvent<E.ListUpdate>;
            list: nbus.util.ISimpleEvent<E.ListUpdate[]>;
            immediate: nbus.util.ISimpleEvent<E.ListUpdate>;
        };
        entity_variable_update: {
            merged: nbus.util.ISimpleEvent<E.EntityVariableReduction>;
            last: nbus.util.ISimpleEvent<E.EntityVariableUpdate>;
            list: nbus.util.ISimpleEvent<E.EntityVariableUpdate[]>;
            immediate: nbus.util.ISimpleEvent<E.EntityVariableUpdate>;
        };
        entity_list_update: {
            merged: nbus.util.ISimpleEvent<E.EntityListReduction>;
            last: nbus.util.ISimpleEvent<E.EntityListUpdate>;
            list: nbus.util.ISimpleEvent<E.EntityListUpdate[]>;
            immediate: nbus.util.ISimpleEvent<E.EntityListUpdate>;
        };
        entity_dispose: {
            immediate: nbus.util.ISimpleEvent<E.EntityDisposed>;
            instrumented_last: nbus.util.ISimpleEvent<nbus.builtin.event_buffers.InstrumentedLast<E.EntityDisposed>>;
            last: nbus.util.ISimpleEvent<E.EntityDisposed>;
            list: nbus.util.ISimpleEvent<E.EntityDisposed[]>;
        };
        block_running: {
            immediate: nbus.util.ISimpleEvent<string>;
            instrumented_last: nbus.util.ISimpleEvent<nbus.builtin.event_buffers.InstrumentedLast<string>>;
            last: nbus.util.ISimpleEvent<string>;
            list: nbus.util.ISimpleEvent<string[]>;
        };
        block_finished: {
            immediate: nbus.util.ISimpleEvent<string>;
            instrumented_last: nbus.util.ISimpleEvent<nbus.builtin.event_buffers.InstrumentedLast<string>>;
            last: nbus.util.ISimpleEvent<string>;
            list: nbus.util.ISimpleEvent<string[]>;
        };
        block_run_result: {
            immediate: nbus.util.ISimpleEvent<E.BlockResult>;
            instrumented_last: nbus.util.ISimpleEvent<nbus.builtin.event_buffers.InstrumentedLast<E.BlockResult>>;
            last: nbus.util.ISimpleEvent<E.BlockResult>;
            list: nbus.util.ISimpleEvent<E.BlockResult[]>;
        };
        test_done: {
            immediate: nbus.util.ISimpleEvent<undefined>;
            count: nbus.util.ISimpleEvent<number>;
        };
    };
};
export declare const DO_NOT_USE__TYPE_INFERENCE_HACK__EB: {
    error: {
        runtime: nbus.builtin.BuiltinEventNeko<E.RuntimeError>;
        all: nbus.builtin.BuiltinEventNeko<E.GeneralError>;
    } & nbus.interfaces.EventBus<"all" | "runtime">;
    warning: {
        runtime: nbus.builtin.BuiltinEventNeko<E.RuntimeError>;
        all: nbus.builtin.BuiltinEventNeko<E.GeneralError>;
    } & nbus.interfaces.EventBus<"all" | "runtime">;
    runtime_manager: {
        after_update: {
            count: nbus.interfaces.EventBuffer<any, number>;
            immediate: nbus.interfaces.EventBuffer<undefined, undefined>;
        } & nbus.interfaces.SignalNeko<"immediate" | "count">;
        before_update: {
            count: nbus.interfaces.EventBuffer<any, number>;
            immediate: nbus.interfaces.EventBuffer<undefined, undefined>;
        } & nbus.interfaces.SignalNeko<"immediate" | "count">;
        restart: {
            count: nbus.interfaces.EventBuffer<any, number>;
            immediate: nbus.interfaces.EventBuffer<undefined, undefined>;
        } & nbus.interfaces.SignalNeko<"immediate" | "count">;
        stop: {
            count: nbus.interfaces.EventBuffer<any, number>;
            immediate: nbus.interfaces.EventBuffer<undefined, undefined>;
        } & nbus.interfaces.SignalNeko<"immediate" | "count">;
        start: {
            count: nbus.interfaces.EventBuffer<any, number>;
            immediate: nbus.interfaces.EventBuffer<undefined, undefined>;
        } & nbus.interfaces.SignalNeko<"immediate" | "count">;
        idle: {
            count: nbus.interfaces.EventBuffer<any, number>;
            immediate: nbus.interfaces.EventBuffer<undefined, undefined>;
        } & nbus.interfaces.SignalNeko<"immediate" | "count">;
    } & nbus.interfaces.EventBus<"stop" | "start" | "after_update" | "before_update" | "restart" | "idle">;
    runtime_data: {
        variable_update: {
            immediate: nbus.interfaces.EventBuffer<E.VariableUpdate, E.VariableUpdate>;
            instrumented_last: nbus.interfaces.EventBuffer<E.VariableUpdate, nbus.builtin.event_buffers.InstrumentedLast<E.VariableUpdate>>;
            last: nbus.interfaces.EventBuffer<E.VariableUpdate, E.VariableUpdate>;
            list: nbus.interfaces.EventBuffer<E.VariableUpdate, E.VariableUpdate[]>;
        } & {
            merged: nbus.interfaces.EventBuffer<E.VariableUpdate, E.VariableReduction>;
        } & nbus.interfaces.Neko<E.VariableUpdate, "immediate" | "instrumented_last" | "last" | "list" | "merged">;
        list_update: {
            immediate: nbus.interfaces.EventBuffer<E.ListUpdate, E.ListUpdate>;
            instrumented_last: nbus.interfaces.EventBuffer<E.ListUpdate, nbus.builtin.event_buffers.InstrumentedLast<E.ListUpdate>>;
            last: nbus.interfaces.EventBuffer<E.ListUpdate, E.ListUpdate>;
            list: nbus.interfaces.EventBuffer<E.ListUpdate, E.ListUpdate[]>;
        } & {
            merged: nbus.interfaces.EventBuffer<E.ListUpdate, E.ListUpdateReduction>;
        } & nbus.interfaces.Neko<E.ListUpdate, "immediate" | "instrumented_last" | "last" | "list" | "merged">;
        entity_variable_update: {
            immediate: nbus.interfaces.EventBuffer<E.EntityVariableUpdate, E.EntityVariableUpdate>;
            instrumented_last: nbus.interfaces.EventBuffer<E.EntityVariableUpdate, nbus.builtin.event_buffers.InstrumentedLast<E.EntityVariableUpdate>>;
            last: nbus.interfaces.EventBuffer<E.EntityVariableUpdate, E.EntityVariableUpdate>;
            list: nbus.interfaces.EventBuffer<E.EntityVariableUpdate, E.EntityVariableUpdate[]>;
        } & {
            merged: nbus.interfaces.EventBuffer<E.EntityVariableUpdate, E.EntityVariableReduction>;
        } & nbus.interfaces.Neko<E.EntityVariableUpdate, "immediate" | "instrumented_last" | "last" | "list" | "merged">;
        entity_list_update: {
            immediate: nbus.interfaces.EventBuffer<E.EntityListUpdate, E.EntityListUpdate>;
            instrumented_last: nbus.interfaces.EventBuffer<E.EntityListUpdate, nbus.builtin.event_buffers.InstrumentedLast<E.EntityListUpdate>>;
            last: nbus.interfaces.EventBuffer<E.EntityListUpdate, E.EntityListUpdate>;
            list: nbus.interfaces.EventBuffer<E.EntityListUpdate, E.EntityListUpdate[]>;
        } & {
            merged: nbus.interfaces.EventBuffer<E.EntityListUpdate, E.EntityListReduction>;
        } & nbus.interfaces.Neko<E.EntityListUpdate, "immediate" | "instrumented_last" | "last" | "list" | "merged">;
        entity_dispose: nbus.builtin.BuiltinEventNeko<E.EntityDisposed>;
        block_run_result: nbus.builtin.BuiltinEventNeko<E.BlockResult>;
        test_done: {
            count: nbus.interfaces.EventBuffer<any, number>;
            immediate: nbus.interfaces.EventBuffer<undefined, undefined>;
        } & nbus.interfaces.SignalNeko<"immediate" | "count">;
        block_running: nbus.builtin.BuiltinEventNeko<string>;
        block_finished: nbus.builtin.BuiltinEventNeko<string>;
    } & nbus.interfaces.EventBus<"variable_update" | "list_update" | "entity_variable_update" | "entity_list_update" | "entity_dispose" | "block_run_result" | "test_done" | "block_running" | "block_finished">;
    system: {
        config_updated: {
            count: nbus.interfaces.EventBuffer<any, number>;
            immediate: nbus.interfaces.EventBuffer<undefined, undefined>;
        } & nbus.interfaces.SignalNeko<"immediate" | "count">;
    } & nbus.interfaces.EventBus<"config_updated">;
    clones: {
        dispose_clone: nbus.builtin.BuiltinEventNeko<string>;
    } & nbus.interfaces.EventBus<"dispose_clone">;
} & nbus.interfaces.EventCategories<"error" | "warning" | "runtime_manager" | "runtime_data" | "system" | "clones">;
export declare type EventBusPrivate = typeof DO_NOT_USE__TYPE_INFERENCE_HACK__EB;
export declare const DO_NOT_USE__TYPE_INFERENCE_HACK__EB_PUB: {
    error: {
        runtime: {
            immediate: nbus.util.ISimpleEvent<E.RuntimeError>;
            instrumented_last: nbus.util.ISimpleEvent<nbus.builtin.event_buffers.InstrumentedLast<E.RuntimeError>>;
            last: nbus.util.ISimpleEvent<E.RuntimeError>;
            list: nbus.util.ISimpleEvent<E.RuntimeError[]>;
        };
        all: {
            immediate: nbus.util.ISimpleEvent<E.GeneralError>;
            instrumented_last: nbus.util.ISimpleEvent<nbus.builtin.event_buffers.InstrumentedLast<E.GeneralError>>;
            last: nbus.util.ISimpleEvent<E.GeneralError>;
            list: nbus.util.ISimpleEvent<E.GeneralError[]>;
        };
    };
    warning: {
        runtime: {
            immediate: nbus.util.ISimpleEvent<E.RuntimeError>;
            instrumented_last: nbus.util.ISimpleEvent<nbus.builtin.event_buffers.InstrumentedLast<E.RuntimeError>>;
            last: nbus.util.ISimpleEvent<E.RuntimeError>;
            list: nbus.util.ISimpleEvent<E.RuntimeError[]>;
        };
        all: {
            immediate: nbus.util.ISimpleEvent<E.GeneralError>;
            instrumented_last: nbus.util.ISimpleEvent<nbus.builtin.event_buffers.InstrumentedLast<E.GeneralError>>;
            last: nbus.util.ISimpleEvent<E.GeneralError>;
            list: nbus.util.ISimpleEvent<E.GeneralError[]>;
        };
    };
    runtime_manager: {
        after_update: {
            immediate: nbus.util.ISimpleEvent<undefined>;
            count: nbus.util.ISimpleEvent<number>;
        };
        before_update: {
            immediate: nbus.util.ISimpleEvent<undefined>;
            count: nbus.util.ISimpleEvent<number>;
        };
        restart: {
            immediate: nbus.util.ISimpleEvent<undefined>;
            count: nbus.util.ISimpleEvent<number>;
        };
        stop: {
            immediate: nbus.util.ISimpleEvent<undefined>;
            count: nbus.util.ISimpleEvent<number>;
        };
        start: {
            immediate: nbus.util.ISimpleEvent<undefined>;
            count: nbus.util.ISimpleEvent<number>;
        };
        idle: {
            immediate: nbus.util.ISimpleEvent<undefined>;
            count: nbus.util.ISimpleEvent<number>;
        };
    };
    runtime_data: {
        variable_update: {
            merged: nbus.util.ISimpleEvent<E.VariableReduction>;
            last: nbus.util.ISimpleEvent<E.VariableUpdate>;
            list: nbus.util.ISimpleEvent<E.VariableUpdate[]>;
            immediate: nbus.util.ISimpleEvent<E.VariableUpdate>;
        };
        list_update: {
            merged: nbus.util.ISimpleEvent<E.ListUpdateReduction>;
            last: nbus.util.ISimpleEvent<E.ListUpdate>;
            list: nbus.util.ISimpleEvent<E.ListUpdate[]>;
            immediate: nbus.util.ISimpleEvent<E.ListUpdate>;
        };
        entity_variable_update: {
            merged: nbus.util.ISimpleEvent<E.EntityVariableReduction>;
            last: nbus.util.ISimpleEvent<E.EntityVariableUpdate>;
            list: nbus.util.ISimpleEvent<E.EntityVariableUpdate[]>;
            immediate: nbus.util.ISimpleEvent<E.EntityVariableUpdate>;
        };
        entity_list_update: {
            merged: nbus.util.ISimpleEvent<E.EntityListReduction>;
            last: nbus.util.ISimpleEvent<E.EntityListUpdate>;
            list: nbus.util.ISimpleEvent<E.EntityListUpdate[]>;
            immediate: nbus.util.ISimpleEvent<E.EntityListUpdate>;
        };
        entity_dispose: {
            immediate: nbus.util.ISimpleEvent<E.EntityDisposed>;
            instrumented_last: nbus.util.ISimpleEvent<nbus.builtin.event_buffers.InstrumentedLast<E.EntityDisposed>>;
            last: nbus.util.ISimpleEvent<E.EntityDisposed>;
            list: nbus.util.ISimpleEvent<E.EntityDisposed[]>;
        };
        block_running: {
            immediate: nbus.util.ISimpleEvent<string>;
            instrumented_last: nbus.util.ISimpleEvent<nbus.builtin.event_buffers.InstrumentedLast<string>>;
            last: nbus.util.ISimpleEvent<string>;
            list: nbus.util.ISimpleEvent<string[]>;
        };
        block_finished: {
            immediate: nbus.util.ISimpleEvent<string>;
            instrumented_last: nbus.util.ISimpleEvent<nbus.builtin.event_buffers.InstrumentedLast<string>>;
            last: nbus.util.ISimpleEvent<string>;
            list: nbus.util.ISimpleEvent<string[]>;
        };
        block_run_result: {
            immediate: nbus.util.ISimpleEvent<E.BlockResult>;
            instrumented_last: nbus.util.ISimpleEvent<nbus.builtin.event_buffers.InstrumentedLast<E.BlockResult>>;
            last: nbus.util.ISimpleEvent<E.BlockResult>;
            list: nbus.util.ISimpleEvent<E.BlockResult[]>;
        };
        test_done: {
            immediate: nbus.util.ISimpleEvent<undefined>;
            count: nbus.util.ISimpleEvent<number>;
        };
    };
};
export declare type EventBusPublic = typeof DO_NOT_USE__TYPE_INFERENCE_HACK__EB_PUB;
