import { Compiler, Ohno, BlockUtil, BlockPool, BlockRegistry } from './di_interfaces';
import { MaybeCompiledEntities, UncompiledEntity, ForcedBlockIds } from './basic_types';
export declare class HtmlParserCompilerImpl implements Compiler {
    private block_pool;
    private html_parser;
    private ohno;
    private block;
    private block_registry;
    constructor(block_pool: BlockPool, html_parser: any, ohno: Ohno, block: BlockUtil, block_registry: BlockRegistry);
    private is_hat_block(block_type);
    private compile_entity(entity, force_compile_block_ids?);
    compile(entities: UncompiledEntity[], force_compile_block_ids?: ForcedBlockIds, compile_all_blocks?: boolean): MaybeCompiledEntities;
    private compile_from_workspace_xml(xml_string, force_compile_block_ids?);
    private parse_xml_field(xml_dom);
    private xml_to_json(xml_dom, parent?);
    private responder_to_json(pre_block, child_nodes);
    private event_to_json(pre_block, child_nodes);
    private loop_to_json(pre_block, child_nodes);
    private tell_to_json(pre_block, child_nodes);
    private warp_to_json(pre_block, child_nodes);
    private conditional_to_json(pre_block, child_nodes);
    private procedure_to_json(pre_block, child_nodes);
    private procedure_definition_to_json(pre_block, child_nodes);
    private procedure_call_return_to_json(pre_block, child_nodes);
    private procedure_call_no_return_to_json(pre_block, child_nodes);
}
