import * as BLK from '../block_types';
import * as H from '../di_interfaces';
import * as O from './types';
import { ID } from '../basic_types';
export declare class OptiCompilerImpl implements H.OptiCompiler {
    private block_pool;
    private block_registry;
    private event_bus;
    private log;
    private ohno;
    private prng_factory;
    private u;
    private block;
    private config;
    private deterministic;
    private should_pretty_print;
    private keyword;
    constructor(block_pool: H.BlockPool, block_registry: H.BlockRegistry, event_bus: H.EventBusPrivate, log: H.Logger, ohno: H.Ohno, prng_factory: H.PRNGFactory, u: H.Util, block: H.BlockUtil, config: H.Config);
    private create_catch_all_error(location, error, ast?);
    compile(source_map_entity: ID, source_map_rbid: ID, interpreter_id: ID, ast: BLK.CompiledBlock): O.OptiProgram;
    private wrap_with_top_level(program);
    private compile_statement(state, ast?);
    private compile_expression(state, ast);
    private compile_conditional(state, ast);
    private compile_sync_tell(state, ast);
    private compile_warp(state, ast);
    private compile_async_tell(state, ast);
    private compile_repeat_forever(state, ast);
    private compile_repeat_forever_until(state, ast);
    private compile_repeat_n_times(state, ast);
    private compile_wait_until(state, ast);
    private compile_break(state, ast);
    private compile_logic_empty(state, ast);
    private compile_domain_functions(state, ast);
    private compile_event(state, ast);
    private compile_responder(state, ast);
    private compile_procedure_call(state, ast);
    private compile_procedure_parameter(state, ast);
    private compile_procedure_return_value(state, ast);
    private compile_params(state, name, params);
    private opt_static(key);
    private opt_params(key);
    private opt_create_params(key);
    private opt_set_param(key, param, value);
}
