import * as BLK from '../block_types';
import * as H from '../di_interfaces';
import * as T from '../basic_types';
export declare class OptiRunnerFactory implements H.BlockInterpreterFactory {
    private u;
    private ohno;
    private event_bus;
    private block_registry;
    private program_cache;
    private block_pool;
    private should_pretty_print;
    private tell_should_ensure_entity_exists;
    private should_report_current_running_block;
    private max_procedure_calls_per_interpreter_step;
    private max_warp_iterations_per_interpreter_step;
    private max_call_stack_size;
    constructor(u: H.Util, ohno: H.Ohno, event_bus: H.EventBusPrivate, block_registry: H.BlockRegistry, program_cache: H.OptiProgramCache, block_pool: H.BlockPool);
    create(run_mgr: H.RuntimeManager, identities: T.Identities, priorities: T.InterpreterPriorities, compile_cache_id: T.ID, compiled_block: BLK.CompiledBlock, variable_specs: T.VariableSpecDict, group_id: string | undefined, is_warped: boolean, action_parameters?: T.Dict<any>, on_finished?: H.OnInterpreterFinished): H.BlockInterpreter;
    clear(): void;
}
