"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var inversify_1 = require("inversify");
var H = require("../di_interfaces");
var di_symbols_1 = require("../di_symbols");
var runner_1 = require("./runner");
var OptiRunnerFactory = (function () {
    function OptiRunnerFactory(u, ohno, event_bus, block_registry, program_cache, block_pool) {
        var _this = this;
        this.u = u;
        this.ohno = ohno;
        this.event_bus = event_bus;
        this.block_registry = block_registry;
        this.program_cache = program_cache;
        this.block_pool = block_pool;
        var configure = function () {
            var conf = u.config.get();
            var opti_conf = conf.opti_compiler;
            _this.should_pretty_print = opti_conf != undefined ? opti_conf.pretty_print : false;
            _this.tell_should_ensure_entity_exists = conf.reports_all_entities;
            _this.should_report_current_running_block = conf.should_report_current_running_block;
            _this.max_procedure_calls_per_interpreter_step = conf.max_warp_iterations_per_interpreter_step;
            _this.max_warp_iterations_per_interpreter_step = conf.max_warp_iterations_per_interpreter_step;
            _this.max_call_stack_size = conf.max_call_stack_size;
        };
        configure();
        this.event_bus.system.config_updated.immediate.sub(configure);
    }
    OptiRunnerFactory.prototype.create = function (run_mgr, identities, priorities, compile_cache_id, compiled_block, variable_specs, group_id, is_warped, action_parameters, on_finished) {
        return new runner_1.OptiRunner(this.u, this.ohno, this.should_pretty_print, this.tell_should_ensure_entity_exists, this.should_report_current_running_block, this.max_procedure_calls_per_interpreter_step, this.max_warp_iterations_per_interpreter_step, run_mgr, this.block_pool, this.program_cache, this.block_registry.get_domain_functions(), identities, priorities, this.program_cache.get_program(compile_cache_id, identities.source_map_entity, identities.source_map_rbid, identities.interpreter_id, compiled_block), group_id, compiled_block, variable_specs, is_warped, this.max_call_stack_size, action_parameters, on_finished);
    };
    OptiRunnerFactory.prototype.clear = function () {
        this.program_cache.clear();
    };
    OptiRunnerFactory = tslib_1.__decorate([
        inversify_1.injectable(),
        tslib_1.__param(0, inversify_1.inject(di_symbols_1.BINDING.Util)),
        tslib_1.__param(1, inversify_1.inject(di_symbols_1.BINDING.Ohno)),
        tslib_1.__param(2, inversify_1.inject(di_symbols_1.BINDING.EventBus)),
        tslib_1.__param(3, inversify_1.inject(di_symbols_1.BINDING.BlockRegistry)),
        tslib_1.__param(4, inversify_1.inject(di_symbols_1.BINDING.OptiProgramCache)),
        tslib_1.__param(5, inversify_1.inject(di_symbols_1.BINDING.BlockPool)),
        tslib_1.__metadata("design:paramtypes", [Object, Object, Object, Object, Object, Object])
    ], OptiRunnerFactory);
    return OptiRunnerFactory;
}());
exports.OptiRunnerFactory = OptiRunnerFactory;
