"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var inversify_1 = require("inversify");
var H = require("../di_interfaces");
var di_symbols_1 = require("../di_symbols");
var OptiProgramCacheImpl = (function () {
    function OptiProgramCacheImpl(u, ohno, event_bus, block_registry, opti_compiler, block_pool) {
        this.u = u;
        this.ohno = ohno;
        this.event_bus = event_bus;
        this.block_registry = block_registry;
        this.opti_compiler = opti_compiler;
        this.block_pool = block_pool;
        this.programs = {};
    }
    OptiProgramCacheImpl.prototype.get_program = function (cache_id, source_map_entity, source_map_rbid, interpreter_id, compiled_block) {
        var program_id = cache_id;
        var stored_program = this.programs[program_id];
        if (stored_program != undefined) {
            return stored_program;
        }
        var program = this.opti_compiler.compile(source_map_entity, source_map_rbid, interpreter_id, compiled_block);
        this.programs[program_id] = program;
        return program;
    };
    OptiProgramCacheImpl.prototype.clear = function () {
        this.programs = {};
    };
    OptiProgramCacheImpl = tslib_1.__decorate([
        inversify_1.injectable(),
        tslib_1.__param(0, inversify_1.inject(di_symbols_1.BINDING.Util)),
        tslib_1.__param(1, inversify_1.inject(di_symbols_1.BINDING.Ohno)),
        tslib_1.__param(2, inversify_1.inject(di_symbols_1.BINDING.EventBus)),
        tslib_1.__param(3, inversify_1.inject(di_symbols_1.BINDING.BlockRegistry)),
        tslib_1.__param(4, inversify_1.inject(di_symbols_1.BINDING.OptiCompiler)),
        tslib_1.__param(5, inversify_1.inject(di_symbols_1.BINDING.BlockPool)),
        tslib_1.__metadata("design:paramtypes", [Object, Object, Object, Object, Object, Object])
    ], OptiProgramCacheImpl);
    return OptiProgramCacheImpl;
}());
exports.OptiProgramCacheImpl = OptiProgramCacheImpl;
