import * as BLK from '../block_types';
import * as H from '../di_interfaces';
import * as O from './types';
import * as T from '../basic_types';
import { FunctionDict } from '../block_provider';
export declare class OptiRunner implements H.BlockInterpreter {
    private u;
    private ohno;
    private should_pretty_print;
    private tell_should_ensure_entity_exists;
    private should_report_current_running_block;
    private max_procedure_calls_per_interpreter_step;
    private max_warp_iterations_per_interpreter_step;
    private run_mgr;
    private block_pool;
    private program_cache;
    private domain_functions;
    private original_identities;
    private priorities;
    private program;
    private max_call_stack_size;
    private action_parameters;
    private on_finished;
    readonly metadata: T.InterpreterMetadata;
    private root_block_type;
    private root_block_id;
    private program_state;
    private step_outputs;
    private step_input_outputs;
    private domain_function_util;
    private variables;
    private variables_stack;
    private original_variables;
    private programs;
    private current_frame;
    private n_warp_iterations;
    constructor(u: H.Util, ohno: H.Ohno, should_pretty_print: boolean, tell_should_ensure_entity_exists: boolean, should_report_current_running_block: boolean, max_procedure_calls_per_interpreter_step: number, max_warp_iterations_per_interpreter_step: number, run_mgr: H.RuntimeManager, block_pool: H.BlockPool, program_cache: H.OptiProgramCache, domain_functions: FunctionDict, original_identities: T.Identities, priorities: T.InterpreterPriorities, program: O.OptiProgram, group_id: string | undefined, compiled_block: BLK.CompiledBlock, variable_specs: T.VariableSpecDict, is_warped: boolean, max_call_stack_size: number, action_parameters?: T.Dict<any> | undefined, on_finished?: H.OnInterpreterFinished | undefined);
    reset(is_warped?: boolean): void;
    private get_action_parameter(parameter_id);
    private step_call_procedure(function_id, target_entity_id, parameters, proc_call_bid, is_inside_warp);
    private step_yield_to_procedure(yield_group_id, next_statement_id);
    private step_iteration_yield(is_inside_warp);
    private step_before_expression(block_id, source_map_entity, source_map_rbid, yield_group_id, next_statement_id);
    private step_after_potential_blocker(block_id, source_map_entity, source_map_rbid, yield_group_id, next_statement_id);
    private step_increment_program_counter(source_map_entity, source_map_rbid, yield_group_id, next_statement_id);
    private step_reset_program_counter(source_map_entity, source_map_rbid, yield_group_id);
    private step_finished();
    private step_return_value(block_id, value);
    private step_call_domain_function(return_value_storage_id, function_id, block_id, args, target_entity);
    private extend_domain_function_call_error(e, block_id, function_id, source_map_rbid, source_map_entity);
    private ensure_tell_target_ok(block_id, target_entity);
    private step_async_tell(block_id, target_entity, new_target_entity, is_inside_warp);
    private step_report_sync_telling(block_id, target_entity);
    private empty_stack_frame(id, target_entity_id, program, is_warped, proc_params?, source_map_entity?, source_map_rbid?, proc_call_bid?);
    private empty_state(target_entity_id, is_warped);
    private get_step_args(frame, static_data);
    step(): T.StepResult;
    private do_step();
    get_current_stack(): T.RuntimeStackMetadata[];
    dispose(): void;
    set_variable(name: string, value: any): void;
    get_variable(name: string): any;
    get_variables(): T.VariableStore;
}
