import * as H from './di_interfaces';
import { ID } from './basic_types';
import { ActionStateQueryParams } from './public_interfaces';
export declare class RuntimeDataImpl implements H.RuntimeData {
    private state_store;
    private event_bus;
    private u;
    private config;
    private per_entity_clone_limit;
    private _clone_id_2_original_id;
    private original_id_2_clone_id_list;
    private _is_mirror;
    private run_status;
    private arbitrary_data;
    private interpreter_data;
    private running_blocks_map;
    private should_report_current_running_block;
    constructor(state_store: H.ActionStateStore, event_bus: H.EventBusPrivate, u: H.Util, config: H.Config);
    clear(): void;
    set_mirror(interpreter_id: ID): void;
    is_mirror(interpreter_id: ID): boolean;
    set_arbitrary_data(key: string, value: any): void;
    get_arbitrary_data(key: string): any | undefined;
    set_interpreter_data(interpreter_id: ID, key: string, value: any): void;
    get_interpreter_data(interpreter_id: ID, key: string): any;
    dispose_interpreter_data(interpreter_id: ID): void;
    report_variable_updated(var_id: string, new_value: any): void;
    report_list_updated(list_id: string, new_value: any): void;
    report_entity_variable_updated(var_id: string, new_value: any, entity_id: string): void;
    report_entity_list_updated(list_id: string, new_value: any, entity_id: string): void;
    is_running(): boolean;
    is_stopped(): boolean;
    set_running(): void;
    set_stopped(): void;
    clone_id_2_original_id(entity_id: ID): ID | undefined;
    get_sprite_clones(sprite_id: ID): ID[];
    clone_created(original_entity_id: string, clone_entity_id: string): void;
    private remove_clone_lookups(removed_id);
    entity_disposed(removed_id: ID): void;
    get_action_state_value(params: ActionStateQueryParams): string;
    set_running_block(interpreter_id: ID, running_block_id: ID): void;
    private set_finished_block(finished_block_id);
    private clear_running_blocks_map();
}
