import * as H from './di_interfaces';
import { ID, Task, TaskHandle } from './basic_types';
export declare class TaskManagerImpl implements H.TaskManager {
    private event_bus;
    private runtime_data;
    private u;
    private ms_per_update;
    private update_function;
    private tasks;
    private tasks_needing_dispose;
    private interpreter_n_blockers_lookup;
    constructor(event_bus: H.EventBusPrivate, runtime_data: H.RuntimeData, u: H.Util);
    clear(): void;
    update_dispose(): void;
    update(): void;
    add_task(id: ID, t: Task): TaskHandle;
    is_blocking(rbid: ID): boolean;
    dispose_task(task_id: ID): void;
    dispose_tasks_given(match: Partial<H.RunningTask>): void;
    private now();
    private deterministic_task_update(t);
    private wall_clock_task_update(t);
}
