import { TestAssertionTool } from '../di_interfaces';
import { AssertionToolResult } from '../public_interfaces';
export declare enum AssertType {
    pass = 0,
    fail = 1,
    truthy = 2,
    falsy = 3,
    is = 4,
    not = 5,
}
export interface Assert {
    type: AssertType;
    params?: {
        value: number | boolean | string;
        expected?: number | boolean | string;
    };
    message: string;
}
export declare class TestAssertionToolImpl implements TestAssertionTool {
    private passed;
    private failed;
    private planned;
    plan(n_tests: number): void;
    fail(message?: string): void;
    pass(message?: string): void;
    truthy(obj: any, message?: string): void;
    falsy(obj: any, message?: string): void;
    is(value: any, expected: any, message?: string): void;
    not(value: any, expected: any, message?: string): void;
    get_result(): AssertionToolResult;
    reset(): void;
    private get_plural_by_amt(amt);
    private update_planned_result();
}
