import { ID } from './basic_types';
import { BlockXML, Toolbox, ToolboxFactory, Util } from './di_interfaces';
export declare type XMLString = string;
export declare type HTMLElement = any;
export interface ToolboxConfig {
    id: ID;
    type: string;
    categories: ToolboxCategoryConfig[];
}
export interface ToolboxCategoryConfig {
    category_name: string;
    color: string;
    icon: IconConfig;
    blocks?: XMLString[];
    custom?: string;
}
export interface IconConfig {
    normal_icon_css: string;
    selected_icon_css: string;
}
export declare class ToolboxFactoryImpl implements ToolboxFactory {
    private u;
    constructor(u: Util);
    create(toolbox_config: ToolboxConfig, block_xml: BlockXML): Toolbox;
}
