import * as B from '../../di_interfaces';
import { ContextMenu } from '../../di_interfaces';
import { BkySVGElement } from './block_svg';
import Blockly = B.Blockly;
import Utils = B.Utils;
import Block = B.Block;
import Input = B.Input;
export declare type Constructor<T> = new (...args: any[]) => T;
export declare function block_render_svg(BlockSvgBase: typeof B.BlockSvg): {
    new (workspace: any, prototypeName?: string | undefined, opt_id?: string | undefined): {
        squareTopLeftCorner_: boolean;
        squareBottomLeftCorner_: boolean;
        startHat_: boolean;
        render(opt_bubble?: boolean | undefined): void;
        renderFields_(fieldList: any[], cursorX: number, cursorY: number, rowHeight?: number | undefined): number;
        renderFieldsMiddle_(fieldList: any[], cursorX: number, cursorY: number, rowHeight: number): number;
        renderCompute_(iconWidth: number): any;
        renderDraw_(iconWidth: number, inputRows: any): void;
        renderMoveConnections_: () => void;
        renderDrawTop_(steps: string[], rightEdge: number): void;
        renderDrawRight_(steps: string[], inlineSteps: string[], inputRows: any, iconWidth: number): number;
        renderRowCollapsed_(steps: string[], cursorX: number, cursorY: number, row: any): void;
        renderRowInline_(steps: string[], inlineSteps: string[], cursorX: number, cursorY: number, row: any, inputRows: any): void;
        renderRowInputValue_(steps: string[], inlineSteps: string[], cursorX: number, cursorY: number, row: any, inputRows: any): void;
        renderRowDummyInput_(steps: string[], inlineSteps: string[], cursorX: number, cursorY: number, row: any, inputRows: any): void;
        renderDrawBottom_(steps: string[], cursorY: number): void;
        renderDrawLeft_(steps: string[]): void;
        getHeightWidth(): {
            height: number;
            width: number;
        };
        Blockly: Blockly;
        utils: Utils;
        goog: any;
        COLOUR_2_BORDER: any;
        context_menu: ContextMenu;
        moveBy(dx: number, dy: number): void;
        dispose: (healStack: boolean, animate: boolean) => void;
        getIcons: () => any[];
        getSvgRoot: () => Element;
        makeConnection_(type: number): any;
        showContextMenu_(e: Event): void;
        updateColour(): void;
        addError(): void;
        removeError(): void;
        rendered: boolean;
        svgGroup_: BkySVGElement;
        svgPath_: BkySVGElement;
        useDragSurface_: boolean;
        customContextMenu: any;
        height: number;
        width: number;
        addMutation: any;
        removeMutation: any;
        addSelect: () => void;
        removeSelect: () => void;
        getComputedTextLength: () => number;
        moveConnections_: (dx: number, dy: number) => void;
        showHelp_: () => void;
        translate: (x: number, y: number) => void;
        interpolate_(message: string, args: any[], lastDummyAlign: string): void;
        getCommentText(): any;
        append_shadow_input(name: string, str: string): any;
        append_shadow(type: number, name: string, str: string): any;
        transform_string_to_xml(xml_string: string): any;
        set_rendered: (new_boolean: boolean) => void;
        init?: (() => void) | undefined;
        isInMutator: boolean;
        onchange: Function;
        outputConnection: any;
        is_edit: boolean;
        flyoutRect_: any;
        id: string;
        mutationToDom: Function | undefined;
        inputsInline: boolean | undefined;
        data: string | undefined;
        inputsInlineDefault: boolean | undefined;
        is_edit_block(): boolean;
        set_edit_block(edit: boolean): void;
        nextConnection: any;
        previousConnection: any;
        disabled: boolean;
        type: string;
        comment: any;
        helpUrl: string | Function;
        workspace: any;
        isInFlyout: boolean;
        RTL: boolean;
        movable_: boolean;
        editable_: boolean;
        isShadow_: boolean;
        inputList: Input[];
        tooltip: string;
        contextMenu: boolean;
        parentBlock_: Block | undefined;
        childBlocks_: Block[];
        deletable_: boolean;
        collapsed_: boolean;
        xy_: any;
        getInputsInline: () => void;
        isCollapsed: () => boolean;
        setCollapsed: (collapsed: boolean) => void;
        setCommentText: (text?: string | undefined) => void;
        getRelativeToSurfaceXY: () => any;
        appendValueInput: (name: string) => Input;
        appendStatementInput: (name: string) => Input;
        appendDummyInput: (opt_name?: string | undefined) => Input;
        getColour: () => string;
        getDescendants: () => Block[];
        getParent: () => Block;
        getNextBlock: () => Block;
        getRootBlock: () => Block;
        isDeletable: () => boolean;
        isMovable: () => boolean;
        isShadow: () => boolean;
        isEditable: () => boolean;
        getChildren: () => Block[];
        unplug(opt_healStack?: boolean): void;
        bumpNeighbours_: () => void;
        getVars: () => string[];
        setOnChange: (onchangeFn: Function) => void;
    };
    SEP_SPACE_X: number;
    SEP_SPACE_Y: number;
    BORDER_WIDTH: number;
    INLINE_PADDING_Y: number;
    INLINE_PADDING_Y_SHADOW: number;
    MIN_BLOCK_Y: number;
    MIN_BLOCK_FIELD_Y: number;
    MIN_BLOCK_Y_SHADOW: number;
    TAB_HEIGHT: number;
    TAB_WIDTH: number;
    TAB_WIDTH_BOOLEAN: number;
    TAB_WIDTH_VAR: number;
    TAB_WIDTH_let: number;
    NOTCH_WIDTH: number;
    NOTCH_HEIGHT: number;
    JAGGED_TEETH: string;
    JAGGED_TEETH_HEIGHT: number;
    JAGGED_TEETH_WIDTH: number;
    INNER_NOTCH_OFFSET: number;
    NOTCH_WIDTH_SHORT: number;
    ROW_HEIGHT_LAST: number;
    CORNER_RADIUS: number;
    START_HAT: boolean;
    START_HAT_HEIGHT: number;
    START_HAT_PATH: string;
    START_HAT_ICON_HEIGHT: number;
    TYPE_IMAGE_HEIGHT: number;
    TYPE_IMAGE_WIDTH: number;
    TYPE_ICON_HEIGHT: number;
    TYPE_ICON_WIDTH: number;
    NOTCH_PATH_LEFT: string;
    NOTCH_PATH_RIGHT: string;
    TAB_PATH_DOWN: string;
    TAB_PATH_DOWN_BOOLEAN: string;
    TAB_PATH_DOWN_RIGHT: string;
    TOP_LEFT_CORNER_START: string;
    TOP_LEFT_CORNER: string;
    INNER_TOP_LEFT_CORNER: string;
    INNER_BOTTOM_LEFT_CORNER: string;
    INLINE: number;
};
