import { interfaces } from 'inversify';
import * as B from '../../di_interfaces';
import { Block } from './block';
export interface BkySVGElement extends HTMLElement {
    translate_: string;
    tooltip: string | Function | Object;
    getComputedTextLength: () => number;
}
export declare const lazy_inject: (serviceIdentifier: string | symbol | interfaces.Newable<any> | interfaces.Abstract<any>) => (proto: any, key: string) => void;
export declare class BlockSvgBase extends Block {
    rendered: boolean;
    svgGroup_: BkySVGElement;
    svgPath_: BkySVGElement;
    useDragSurface_: boolean;
    customContextMenu: any;
    height: number;
    width: number;
    static INLINE: number;
    static TAB_WIDTH: number;
    static INLINE_PADDING_Y_SHADOW: number;
    static SEP_SPACE_X: number;
    static MIN_BLOCK_FIELD_Y: number;
    static MIN_BLOCK_Y: number;
    static TYPE_ICON_WIDTH: number;
    static TYPE_ICON_HEIGHT: number;
    static TAB_PATH_DOWN_BOOLEAN: string;
    static TAB_PATH_DOWN: string;
    static NOTCH_PATH_RIGHT: string;
    static START_HAT_ICON_HEIGHT: number;
    render(opt_bubble?: boolean): void;
    addMutation: any;
    removeMutation: any;
    getHeightWidth(): {
        width: number;
        height: number;
    };
    addSelect: () => void;
    removeSelect: () => void;
    getComputedTextLength: () => number;
    moveConnections_: (dx: number, dy: number) => void;
    showHelp_: () => void;
    translate: (x: number, y: number) => void;
}
export declare class BlockSvg extends BlockSvgBase {
    Blockly: typeof B.Blockly;
    utils: B.Utils;
    goog: any;
    COLOUR_2_BORDER: any;
    context_menu: B.ContextMenu;
    constructor(workspace: any, prototypeName?: string, opt_id?: string);
    moveBy(dx: number, dy: number): void;
    dispose: (healStack: boolean, animate: boolean) => void;
    getIcons: () => any[];
    getSvgRoot: () => Element;
    makeConnection_(type: number): any;
    showContextMenu_(e: Event): void;
    updateColour(): void;
    addError(): void;
    removeError(): void;
}
