import { interfaces } from 'inversify';
import * as B from '../../di_interfaces';
export declare const lazy_inject: (serviceIdentifier: string | symbol | interfaces.Newable<any> | interfaces.Abstract<any>) => (proto: any, key: string) => void;
export declare class BubbleBase {
    protected rendered_: boolean;
    protected anchorXY_: any | undefined;
    protected relativeLeft_: number;
    protected relativeTop_: number;
    protected width_: number;
    protected height_: number;
    protected autoLayout_: boolean;
    static ARROW_ANGLE: number;
    static ARROW_BEND: number;
    static ANCHOR_RADIUS: number;
    protected static onMouseUpWrapper_: any[] | undefined;
    protected static onMouseMoveWrapper_: any[] | undefined;
    resizeCallback_: Function | undefined;
    protected static unbindDragEvents_: () => void;
    protected bubbleMouseMove_: (e: Event) => void;
    protected resizeMouseMove_: (e: Event) => void;
    registerResizeEvent: (callback: Function) => void;
    promote_: () => void;
    setAnchorLocation: (xy: any) => void;
    protected layoutBubble_: () => void;
    protected positionBubble_: () => void;
    getBubbleSize: () => any;
    protected renderArrow_: () => void;
    setColour: (hexColour: string) => void;
    dispose: () => void;
}
export declare class Bubble extends BubbleBase {
    protected utils: B.Utils;
    blockly: B.Blockly;
    protected BlockSvg: typeof B.BlockSvg;
    protected goog: any;
    private getIsCommentFocus_;
    private arrow_radians_;
    private workspace_;
    private content_;
    private shape_;
    private resizeGroup_;
    private bubbleGroup_;
    private bubbleArrow_;
    private bubbleBack_;
    static RESIZE_SIZE: number;
    static BORDER_WIDTH: number;
    static ARROW_THICKNESS: number;
    constructor(workspace: B.WorkspaceSvg, content: Element, shape: Element, anchorXY: any, bubbleWidth: number, bubbleHeight: number, getIsCommentFocus: any);
    private static bubbleMouseUp_;
    private createDom_(content, hasResize);
    private bubbleMouseDown_(e);
    private resizeMouseDown_(e);
    setBubbleSize(width: number, height: number): void;
}
