import { interfaces } from 'inversify';
import * as B from '../../di_interfaces';
import { Field } from './field';
import { BkySVGElement } from '../../public_interfaces';
export declare const lazy_inject: (serviceIdentifier: string | symbol | interfaces.Newable<any> | interfaces.Abstract<any>) => (proto: any, key: string) => void;
export declare class FieldDropdownBase extends Field {
    constructor(menu_generator: DropDownOperators, opt_validator?: Function);
    static ARROW_CHAR: string;
    getOptions: () => any[];
    protected imageElement_: BkySVGElement | undefined;
    protected imageJson_: any;
    protected iconElement_: BkySVGElement | undefined;
    protected icon: {
        src: string;
        width?: number;
        height?: number;
        left?: number;
        top?: number;
        margin?: string;
        padding?: string;
        verticalAlign?: string;
        viewWidth?: string;
        viewHeight?: string;
        alt?: string;
    } | undefined;
    protected value_: any;
    onItemSelected: (menu: any, menuItem: any) => void;
}
export declare type DropDownOperators = (string | Function | undefined)[][];
export declare class FieldDropdown extends FieldDropdownBase {
    protected blockly: B.Blockly;
    protected BlockSvg: typeof B.BlockSvg;
    protected Deps: B.Deps;
    private arrow_;
    constructor(menu_generator: DropDownOperators, opt_validator?: Function);
    init(): void;
    protected render_(): void;
    onItemSelected: (menu: any, menuItem: any) => void;
    private showEditor_();
    setValue(newValue: string): void;
    private is_specical_sourceblock(type);
}
