import { interfaces } from 'inversify';
import * as B from '../../di_interfaces';
import { BkySVGElement } from './block_svg';
import { Workspace } from './workspace';
export declare const lazy_inject: (serviceIdentifier: string | symbol | interfaces.Newable<any> | interfaces.Abstract<any>) => (proto: any, key: string) => void;
export declare class WorkspaceSvgBase extends Workspace {
    getMetrics: any;
    setMetrics: any;
    options: any;
    trashcan: any;
    protected grid_: any;
    protected deleteAreaTrash_: any;
    protected deleteAreaToolbox_: any;
    protected toolbox_: B.Toolbox;
    protected flyout_: B.Flyout;
    protected svgBackground_: BkySVGElement;
    protected svgGroup_: BkySVGElement | undefined;
    protected svgBlockCanvas_: BkySVGElement | undefined;
    protected svgBubbleCanvas_: BkySVGElement | undefined;
    scrollbar: any;
    scrollY: number;
    rendered: boolean;
    scale: number;
    protected onMouseDown_: (e: Event) => void;
    protected blockDragSurface_: any;
    protected workspaceDragSurface_: any;
    protected useWorkspaceDragSurface_: any;
    protected highlightedBlocks_: any[];
    protected audioManager_: any;
    registerToolboxCategoryCallback: (key: string, func: Function) => void;
    protected addTrashcan_: (bottom: number) => number;
    protected addZoomControls_: (bottom: number) => number;
    protected currentGesture_: any;
    zoom: (x: number, y: number, amount: number) => void;
    getParentSvg: () => void;
    getInverseScreenCTM: () => any;
    setScale: (newScale: number) => void;
    cleanUp: () => void;
    recordDeleteAreas: () => void;
    getBubbleCanvas: () => BkySVGElement;
    startDrag: (e: Event, xy: any) => void;
    moveDrag: (e: Event) => any;
}
export declare class WorkspaceSvg extends WorkspaceSvgBase {
    protected blockly: typeof B.Blockly;
    protected utils: B.Utils;
    protected goog: any;
    protected BlockSvg: typeof B.BlockSvg;
    protected context_menu: B.ContextMenu;
    constructor(options: any, opt_blockDragSurface: any, opt_wsDragSurface: any);
    createDom(opt_backgroundClass: string): BkySVGElement;
    paste(xmlBlock: any): void;
    createVariable(name: string): void;
    protected onMouseWheel_(e: any): void;
    protected onMouseScroll_(e: any): void;
    scrollYroll(direction: number): void;
    protected showContextMenu_(e: any): void;
}
