import * as B from '../di_interfaces';
export interface ColorPicker {
    is_enabled(): boolean;
    show(b_dom: HTMLElement): void;
    hide(): void;
    set_block(field: B.FieldColour): void;
}
export interface MIDIEditor {
    set_block(field: B.FieldDropdown): void;
    show(): void;
}
export interface ProjectFnType {
    rename_procedure: (old_name: string, new_name: string) => void;
    clone_procedure: (new_name: string, old_name: string) => void;
    get_procedure: () => void;
    get_legal_procedure_name: (old_name: string, new_name: string) => string;
}
export interface ProceduresCallBack {
    get_prevent_flag: () => boolean;
    get_project: () => ProjectFnType;
    get_workspace_panel: () => any;
    show_input_dialog: (self: any, hash: any) => void;
    classify_procedures: (f: Function, proceduresReturn: any[], proceduresNoReturn: any[]) => any[][];
    is_procedure_legal_inside_warp: (name: string, inside_warped_loop: boolean) => boolean;
}
export interface ModuleDeps {
    color_picker?: ColorPicker;
    midi_editor?: MIDIEditor;
    procedures_callback?: ProceduresCallBack;
    get_procedures?: Function;
    NO_ACTION?: string;
}
export declare class Deps {
    deps: ModuleDeps;
    set(deps: ModuleDeps): void;
    get(): ModuleDeps;
}
